version: "3"
services:
  db:
    container_name: re-partners-db
    image: postgres:alpine
    volumes:
      - ./postgres_data:/var/lib/postgresql/data
    environment:
      - POSTGRES_DB=$DB_NAME
      - POSTGRES_USER=$DB_USER
      - POSTGRES_PASSWORD=$DB_PASSWORD
    ports:
      - $DB_PORT:5432
    healthcheck:
      test: [ "CMD-SHELL", "pg_isready -d ${DB_NAME} -h ${DB_HOST} -U ${DB_USER}" ]
      interval: 5s
      timeout: 5s
      retries: 5
    networks:
      - database
  api:
    container_name: re-partners-api
    build:
      context: $API_PATH
      dockerfile: Dockerfile.dev
      args:
        - ARG_PORT=${API_INTERNAL_PORT}
    volumes:
      - $API_PATH:/app
    ports:
      - $API_EXTERNAL_PORT:$API_INTERNAL_PORT
    environment:
      - DB_HOST=$DB_HOST
      - DB_PORT=$DB_PORT
      - DB_NAME=$DB_NAME
      - DB_USER=$DB_USER
      - DB_PASSWORD=$DB_PASSWORD
    networks:
      - database
    depends_on:
      - db
  migrate:
    image: migrate/migrate:4
    profiles: [ "tools" ]
    volumes:
      - ./$API_PATH/cmd/database/migrations:/migrations
    entrypoint:
      [
        "migrate",
        "-path",
        "/migrations",
        "-database",
        "postgres://${DB_USER}:${DB_PASSWORD}@db:5432/${DB_NAME}?sslmode=disable",
      ]
    command: [ "up" ]
    networks:
      - database
    depends_on:
      db:
        condition: service_healthy
    restart: on-failure
networks:
  database:
volumes:
  postgres_data:
